// dinniz2.h - Definicija klase dinamickih nizova kompleksnih brojeva.

#include "kompl.h"

class DinNiz {
  int duz; Kompl* niz;       // Duzina i pokazivac na elemente.
  void kopiraj (const DinNiz&);           // Kopiranje.
  void brisi () { delete [] niz; }        // Unistavanje.
public:                                   // Konstruktori:
  explicit DinNiz (int d=10)              //   - podrazumevani,
    { niz = new Kompl [duz = d]; }
  DinNiz (const DinNiz &dn)               //   - kopije.
    { kopiraj (dn); }
  ~DinNiz () { delete [] niz; }           // Destruktor.
  DinNiz& operator= (const DinNiz& dn) {  // Dodela vrednosti.
    if (this != &dn) { brisi (); kopiraj (dn); }
    return *this;
  }                                       // Element niza:
  Kompl& operator[] (int i)               //   - promenljivog,
    { return niz[i]; }
  const Kompl& operator[] (int i) const   //   - nepromenljivog.
    { return niz[i]; }
};
