// figura1.h - Klasa geometrijskih figura u ravni.

#ifndef _figura1_h_
#define _figura1_h_

#include "tacka3.h"

class Figura {
  Tacka T;                                  // Teziste figure.
public:
  Figura (const Tacka& tt=ORG): T(tt)  {}   // Konstruktor.
  virtual ~Figura () {}                     // Destruktor.
  Figura& premesti (Real x, Real y)         // Premesanje figure.
    { T = Tacka (x, y); return *this; }
  Figura& pomeri (Real dx, Real dy)         // Pomeranje figure.
    { T = Tacka (T.aps()+dx, T.ord()+dy); return *this; }
  virtual Real O () const =0 ;              // Obim.
  virtual Real P () const =0 ;              // Povrsina.
  virtual Figura* kopija () const =0;       // Stvaranje kopije.
protected:
  virtual void citaj (istream& d)       { d >> T; }          // Citanje.
  virtual void pisi  (ostream& d) const { d << "T=" << T; }  // Pisanje.
  friend istream& operator>>(istream& d, Figura& f) // Uopsteno citanje
    { f.citaj (d); return d; }                               //    i
  friend ostream& operator<<(ostream& d, const Figura& f)    // pisanje.
    { f.pisi  (d); return d; }
};

#endif
