// krug1.h - Definicija klase krugova u ravni.

#include "tacka2.h"
#include <cstdlib>
#include <cmath>
#include <iostream>
using namespace std;

class Krug {
  struct Elem {                // Element zajednicke liste svih krugova.
    Krug* krug;                //   - pokazivac na krug,
    Elem* sled;                //   - pokazivac na sledeci element liste,
    Elem (Krug* k, Elem* s=0); //   - stvaranje elementa liste.
  };
  static Elem* prvi;           // Pocetak zajednicke liste.

  Tacka c; double r;           // Centar i poluprecnik kruga.
  Krug () { r = -1; }          // Stvaranje "praznog" kruga:
                               //   - SAMO za interne potrebe!
  Krug (const Krug &) {}       // Konstruktor kopije:
                               //   - NE SME da se pravi kopija!
public:
  static bool moze (double r, double x, double y);  // Moze li postojati?
  Krug (double rr, double x, double y);      // Stvaranje kruga.
  ~Krug ();                                  // Unistavanje kruga.
  friend double rastojanje (const Krug& k1, const Krug& k2);
                                             // Rastojanje dva kruga.
  bool premesti (double  x, double  y);      // Premestanje kruga.
  bool pomeri   (double dx, double dy);      // Pomeranje kruga.
  void pisi () const;                        // Pisanje kruga.
  static void pisiSve ();                    // Pisanje svih krugova.
};

// Definicije funkcija za neposredno ugradjivanje u kod.

inline double rastojanje (const Krug& k1, const Krug& k2)
  { return k1.c.rastojanje (k2.c) - k1.r - k2.r; } // Rastojanje dva kruga.

inline void Krug::pisi () const              // Pisanje kruga.
  { cout << "K[" << r << ','; ::pisi (c); cout << ']'; }

inline Krug::Elem::Elem (Krug* k, Elem* s)   // Stvaranje elementa liste.
  { krug = k; sled = s; }
