// red3.h - Definicija klase redova neogranicenih kapaciteta.

#include <cstdlib>
using namespace std;

class Red {
  struct Elem {                             // Elementi reda:
    int   pod;                              //   sadraj elementa,
    Elem* sled;                             //   sledeci element;
    Elem (int p, Elem *n=0)                 //   konstruktor.
      { pod = p; sled = n; }
  } ;
  Elem *prvi, *posl;                        // Pocetak i kraj reda.
  int   duz;                                // Duina reda.
  void  kopiraj (const Red& r);             // Kopiranje reda.
  void  brisi ();                           // Brisanje svih elemenata.
public:
  Red () { prvi = posl = 0; duz = 0; }      // Konstruktor praznog reda.
  Red (int a)                               // Konverzija int u Red.
    { prvi = posl = new Elem (a); duz = 1; }
  Red (const Red& r) { kopiraj (r); }       // Konstruktor kopije.
  ~Red () { brisi (); }                     // Destruktor.
  Red& operator=  (const Red& r) {          // Dodela vrednosti.
    if (this != &r) { brisi (); kopiraj (r); }
    return *this;
  }
  int  operator+ () const { return duz; }   // Duina reda.
  bool operator! () const { return ! duz; } // Da li je red prazan?
  Red& operator+=(const Red& r);            // Dodavanje podatka ili reda.
  Red  operator+ (const Red& r) const       // Spoj dva reda.
    { return Red (*this) += r; }
 
  int  operator-- () ;                // Uzimanje podatka sa pocetka.
  int operator-  () const {           // Prvi element.
    if (! prvi) exit (1);
    return prvi->pod;
  }
  Red  operator-  (int k) const ;     // Red bez elemenata jednakih k.
  Red& operator-= (int k)             // Brisanje svih elemenata jednakih k.
    { return *this = *this - k; }
  Red& operator~  ()                  // Brisanje svih elemenata.
    { brisi (); return *this; }
};
