// trougao3.h - Definicija klase trouglova.

#ifndef _trougao3_h_
#define _trougao3_h_

#include "figura1.h"
#include <cmath>
using namespace std;

class Trougao: public Figura {
  Real a, b, c;                                   // Stranice.
public:                                           // Konstruktori:
  Trougao (Real aa=1, const Tacka& tt=ORG)        //   jednakostranicni
    : Figura (tt) { a = b = c = aa; }
  Trougao (Real aa, Real bb, const Tacka& tt=ORG) //   jednakokraki
    : Figura (tt) { a = aa; b = c = bb; }
  Trougao (Real aa, Real bb, Real cc, const Tacka& tt=ORG) // opsti
    : Figura (tt) { a = aa; b = bb; c = cc; }
  Real O () const { return a + b + c; }           // Obim.
  Real P () const {                               // Povrsina.
    Real s = (a + b + c) / 2;
    return sqrt (s * (s-a) * (s-b) * (s-c));
  }
  Trougao* kopija () const                        // Dinamicka kopija.
    { return new Trougao (*this); }
private:
  void citaj (istream& d)                         // Citanje.
    { Figura::citaj (d); d >> a >> b >> c; }
  void pisi  (ostream& d) const {                 // Pisanje.
    d << "trougao ["; Figura::pisi (d);
    d << ", a=" << a << ", b=" << b   << ", c=" << c
      << ", O=" << O() << ", P=" << P() << ']';
  }
};

#endif
